unit SXSkinUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, SXSkinLibrary, SXSkinControl, SXSkinImage, ExtCtrls, Menus, IniFiles,
  SXSkinUtils, StdCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    SXSkinImage1: TSXSkinImage;
    SXSkinLibrary1: TSXSkinLibrary;
    MainMenu1: TMainMenu;
    Skins1: TMenuItem;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    SkinNames:TStringList;
    SkinPaths:TStringList;
    procedure SkinChange(Sender:TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var   SR:TSearchRec;
     A,B:Integer;
       L:TStringList;
      S1:String;
 IniFile:TIniFile;
       T:TMenuItem;
begin
 SkinNames:=TStringList.Create;
 SkinPaths:=TStringList.Create;
 S1:=WithlastSlash(ExtractFilePath(Application.ExeName))+'Skins\';
 SXSkinLibrary1.SkinDir:=WithlastSlash(ExtractFilePath(Application.ExeName))+'Skins';
 SXSkinLibrary1.SkinFile2:=SXSkinLibrary1.SkinDir+'\App_Skins\skin.ini';
 L:=TStringList.Create;
 try
  A:=0;
  repeat
   Inc(A);
   if A=1 then B:=FindFirst(S1+'*.*',faDirectory,SR) else
    B:=FindNext(SR);
   if (B=0) and (SR.Name<>'.') and (SR.Name<>'..') then
    L.Add(S1+SR.Name);
  until B<>0;
  FindClose(SR);
  for A:=0 to L.Count-1 do
   if FileExists(L[A]+'\skin.ini') then
    begin
     IniFile:=TIniFile.Create(L[A]+'\skin.ini');
     try
      S1:=IniFile.ReadString('Strings','SkinName','');
      if S1<>'' then
       begin
        SkinNames.Add(S1);
        SkinPaths.Add(L[A]+'\skin.ini');
       end;
     finally
      IniFile.Free;
     end;
    end;
 finally
  L.Free;
 end;
 for A:=0 to SkinNames.Count-1 do
  begin
   T:=TMenuItem.Create(Skins1);
   T.Caption:=SkinNames[A];
   T.Tag:=A;
   T.OnClick:=SkinChange;
   Skins1.Add(T);
   if A=0 then
    SkinChange(T);
  end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 SkinNames.Free;
 SkinPaths.Free;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
 Close;
end;

procedure TForm1.SkinChange(Sender:TObject);
var A:Integer;
begin
 if not (Sender is TMenuItem) then exit;
 for A:=0 to Skins1.Count-1 do
  Skins1.Items[A].Checked:=False;
 TMenuItem(Sender).Checked:=True;
 SXSkinLibrary1.Active:=False;
 if TMenuItem(Sender).Tag<0 then exit;
 SXSkinLibrary1.SkinFile:=SkinPaths[TMenuItem(Sender).Tag];
 SXSkinLibrary1.Active:=True;
end;

end.
